{
  Irrsinniger Winplan Patch

  This fixes auto scrolling under WinXP
}
{$M 16384, 100000, 655360}
{$I-}

{ "NE" Datei Definitionen }
TYPE TNewHeader=RECORD
         Kennung:WORD;
         LinkerVersion,LinkerRevision:BYTE;
         EntryTable:WORD;
         LenEntryTable:WORD;
         Reserved1:LONGINT;
         Flags:WORD;
         AutoDataNr:WORD;
         LocalHeap:WORD;
         StackSize:WORD;
         IP,CS:WORD;
         SP,SS:WORD;
         SegmentNr,ModRefNr,NonResNr:WORD;
         Segment,Resource,ResTable:WORD;
         ModRef,ImpName:WORD;
         NonRes:LONGINT;
         MovableEntPoint:WORD;
         SecShift:WORD;
         ResSegs:WORD;
         TargetOS:BYTE;
         OSInfo:BYTE;
         FastLoad:WORD;
         FastSize:WORD;
         Reserved2:WORD;
         VersionNumber:WORD;
     END;
     TSegment=RECORD
         Pos:WORD;
         Size:WORD;
         Flags:WORD;
         MinSize:WORD;
     END;
     TReference=RECORD
         Typ:BYTE; { 2=16bSelektor 3=32bPtr 5=16bOffset 11=48bPtr 13=32bOfs }
         RefType:BYTE; { 0=int.Ref 1=imported ordinal 2=imported name 3OSFIXUP }
         Offset:WORD;
         CASE BYTE OF
           1:(IndexToModRefTable:WORD;
              FunctionNumber:WORD);
           2:(IdxTMRTable:WORD;
              IndexToImpName:WORD);
           0:(SegNr:BYTE;
              Zero:BYTE;
              SegOffset:WORD);
     END;
     TNameInfo=RECORD
         Offset:WORD;
         Length:WORD;
         Flags:WORD;
         ID:WORD;
         Res:LONGINT;
     END;

PROCEDURE Error(CONST s:STRING);
BEGIN
  Writeln(s);
  Halt(1);
END;

PROCEDURE Blockread(VAR F:FILE; VAR buf; w:WORD);
VAR r:WORD;
BEGIN
  System.BlockRead(F, buf, w, r);
  IF w<>r THEN Error('read error');
END;

CONST MAX_SEGS = 1000;
      MAX_SEG_SIZE = 50000;

CONST STRPOS    = $FFFF;    { replacement only: fills in string address;
                              on search, match anything }
      lv242      = $FFFE;
      nopAddress = $FFFD;
      sub001A    = $FFFC;
      gv0096     = $FFFB;
      fieldC018  = $FFFA;
      mv0036     = $FFF9;
      mv0026     = $FFF8;

      MIN_REPL   = $FFF8;

VAR repl_array : ARRAY[MIN_REPL..STRPOS] OF WORD;

{ Length computation in "load" module. This one appears once. }
CONST code1_len = 43;
      code1 : ARRAY[0..code1_len-1] OF WORD = (
           $67B1,               { nop }
           $3200, lv242,        { push lv242 }
           $37ED,               { push 1 }
           $6AD5, nopAddress,   { nop }
           $62A7, 2, sub001A,   { call sub001A }
           $3834, 30,           { push 30 }
           $38D3,               { %+% }
           $0E7B,               { &(%) }
           $2EE5, mv0026,       { store mv0026 }
           $4942,               { eol }
           $67B1,               { nop }
           $3200, lv242,        { push lv0242 }
           $37ED,               { push 1 }
           $6AD5, nopAddress,   { nop }
           $62A7, $0002, sub001A, { call sub001A }
           $0EB0,               { v(%) }
           $4AA7, gv0096,       { push gv96 }
           $4C09, fieldC018,    { memref fieldC018 }
           $40DF,               { v+v }
           $3834, 30,           { push 30 }
           $0EB0,               { v(%) }
           $416A,               { v-v }
           $1060,               { &(v) }
           $2EE5, mv0036,       { store mv0036 }
           $494B,               { eoln }
           $65D9,               { end sub }
           $0E5E,               { nop }
           $0E5B,               { nop }
           $4942                { eoln }
      );
      code1_rep_len = 11;
      code1_rep : ARRAY[0..code1_rep_len-1] OF WORD = (
           $67B1,               { nop }
           $3200, lv242,        { push lv242 }
           $37ED,               { push 1 }
           $6AD5, nopAddress,   { nop }
           $62A7, 2, sub001A,   { call sub001A }
           $3834, 50            { push 50 <=== change }
      );

{ true iff a matches pattern b }
FUNCTION MemEq(VAR a, b; size:WORD):BOOLEAN;
VAR aa : ARRAY[0..1000] OF WORD ABSOLUTE a;
    bb : ARRAY[0..1000] OF WORD ABSOLUTE b;
    i  : WORD;
BEGIN
  FOR i:=0 TO size-1 DO IF bb[i]>=MIN_REPL THEN BEGIN
    IF (bb[i]<>$FFFF) AND (repl_array[bb[i]]<>0) AND (aa[i]<>repl_array[bb[i]]) THEN
     Writeln('Matcher jammed: want ', repl_array[bb[i]], ' got ', aa[i], ' for ', bb[i]-$FFF0)
    ELSE repl_array[bb[i]] := aa[i];
  END ELSE IF (aa[i]<>bb[i]) THEN BEGIN
    IF i>5 THEN Writeln('found mismatch at ', i, ' (unlikely but possible)');
    MemEq:=FALSE;
    Exit;
  END;
  MemEq:=TRUE;
END;

{ attempt to replace search -> repl in data }
FUNCTION TryReplace(VAR data_; size : WORD;
                    VAR search_; search_len : WORD;
                    VAR repl_; repl_len : WORD) : BOOLEAN;
VAR data : ARRAY[0..MAX_SEG_SIZE DIV 2] OF WORD ABSOLUTE data_;
    search : ARRAY[0..MAX_SEG_SIZE DIV 2] OF WORD ABSOLUTE search_;
    repl : ARRAY[0..MAX_SEG_SIZE DIV 2] OF WORD ABSOLUTE repl_;
    i, n, repl_index : WORD;
LABEL Found;
BEGIN
  size := size DIV 2;
  TryReplace := FALSE;
  IF size < search_len THEN Exit;

  { Locate block to replace }
  FOR i:=0 TO size - search_len DO BEGIN
    FillChar(repl_array, Sizeof(repl_array), 0);
    IF (data[i] = search[0]) AND MemEq(data[i], search, search_len)
     THEN GOTO Found;
  END;
  Exit;
 Found:
  repl_index := i;
  Writeln('Found code to replace at offset ', repl_index);

  FOR i:=0 TO repl_len-1 DO BEGIN
    CASE repl[i] OF
      STRPOS: n := 2*(repl_index + i + 1);
      MIN_REPL..STRPOS: n := repl_array[repl[i]];
    ELSE n := repl[i];
    END;
    data[i+repl_index] := n;
  END;

  TryReplace := TRUE;
END;

{ True iff Segment "data" was modified; changes the segment data in memory }
FUNCTION ProcessSegment(VAR data_; size:WORD):BOOLEAN;
BEGIN
  ProcessSegment := FALSE;
  IF TryReplace(data_, size, code1, code1_len, code1_rep, code1_rep_len)
   THEN BEGIN Writeln('Replaced map initialisation'); ProcessSegment := TRUE; END;
END;

VAR start_offset : LONGINT;
    ne_header    : TNewHeader;
    F            : FILE;
    i, j, k      : INTEGER;
    shdrs        : ARRAY[1..MAX_SEGS] OF TSegment;
    p            : POINTER;
    npatch       : INTEGER;

LABEL ok;

BEGIN
  IF ParamCount<>1 THEN Error('usage: patch <filename>');
  Assign(F, ParamStr(1));
  Reset(F, 1);
  IF IOResult<>0 THEN Error('unable to open ' + ParamStr(1));
  Seek(F, $3C);
  Blockread(F, start_offset, 4);
  IF start_offset <= $3C THEN Error('this is not a Windows NE executable');
  Seek(F, start_offset);
  Blockread(F, ne_header, Sizeof(ne_header));
  IF ne_header.kennung <> $454E THEN Error('this is not a Windows NE executable');
  Seek(F, start_offset + ne_header.segment);
  IF (ne_header.SegmentNr <= 0) OR (ne_header.SegmentNr > MAX_SEGS) THEN
   Error('invalid segment count');
  Blockread(F, shdrs, ne_header.SegmentNr * Sizeof(shdrs[1]));
  npatch := 0;
  FOR i:=1 TO ne_header.SegmentNr DO BEGIN
    WITH shdrs[i] DO
     IF (pos<>0)            { =0 -> segment not initialized }
      AND (size<>0)         { =0 -> size is 64k }
      AND (size<MAX_SEG_SIZE)
      AND (flags AND 1=0)   { != 0 -> data segment }
     THEN BEGIN
       GetMem(p, size);
       Seek(F, LONGINT(pos) SHL ne_header.SecShift);
       Blockread(F, p^, size);
       IF ProcessSegment(p^, size) THEN BEGIN
         Inc(npatch);
         Writeln('-> modified segment ', i);
         Seek(F, LONGINT(pos) SHL ne_header.SecShift);
         Blockwrite(F, p^, size);
       END;
       FreeMem(p, size);
       IF npatch>0 THEN BEGIN
         Writeln('>>> Patch succeeded. <<<');
         GOTO ok;
       END;
     END;
  END;
  Writeln('>>> Patch failed. <<<');
 ok:
  Close(F);
END.
